package edu.stanford.peer.secrmi.test;

import java.io.*; 
import java.rmi.*; 
import java.rmi.server.*; 

import java.security.*;
import edu.stanford.peer.secrmi.*;

public class HelloMain 
{
  
    public static void main(String args[]) { 

        //Create and install a security manager 
        if (System.getSecurityManager() == null) 
            System.setSecurityManager(new RMISecurityManager()); 

		// Check Security providers
		try 
		{
			Provider p[] = Security.getProviders();
			for (int i=0; i<p.length; i++) 
			{
				System.out.println(p[i]);
				for (java.util.Enumeration e = p[i].keys(); e.hasMoreElements();)
					System.out.println("\t" + e.nextElement());
			}
		} 
		catch (Exception e) 
		{
			System.out.println(e);
		}

        try {
			KeyStore ks = SecureServerToolkit.loadKeyStore("JKS", "privateks", "testtest");
			KeyStore ts = SecureServerToolkit.loadKeyStore("JKS", "truststore", "testtest");
			
			System.out.println(ks.toString());
			SecureServerToolkit sst = new SecureServerToolkit(ks, "testtest", ts, "test", "SHA1withRSA");

            HelloImpl obj = new HelloImpl(); 

			SignedRemoteObject sro = sst.exportSignedObject(obj);

			// When a remote proxy is registered, a background thread is created.

			Naming.rebind("/HelloServer", obj);
            Naming.rebind("/SignedHelloServer", sro); 

            System.out.println("HelloServer bound in registry"); 
        } catch (Exception e) { 
            System.out.println("HelloImpl err: " + e.getMessage()); 
            e.printStackTrace(); 
        } 
    } 

/*
	public static void test()
	{
		HelloImp service = new HelloImpl();
		KeyStore  keyStore = SecureServerToolkit.loadKeyStoreFromFile();
		Signature signingEngine = Signature.getInstance("DSA");
	}
*/
}

